<script setup lang="ts">
import BootstrapModal from "@/components/modals/BootstrapModal.vue";
import { computed, onMounted, reactive } from "vue";
import type {
  UserOut,
  WorkflowOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import { useWorkflowStore } from "@/stores/workflows";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";

const props = defineProps<{
  modalId: string;
  backModalId?: string;
  allowSelectWorkflow?: boolean;
}>();
const randomIDSuffix = Math.random().toString(16).substring(2, 8);

const workflowRepository = useWorkflowStore();

const formState = reactive<{
  searchString: string;
  potentialUsers: UserOut[];
  lastSearchTimerId: ReturnType<typeof setTimeout> | null;
  error: boolean;
  loading: boolean;
  selectedWorkflow?: WorkflowOut;
}>({
  searchString: "",
  potentialUsers: [],
  lastSearchTimerId: null,
  error: false,
  loading: false,
  selectedWorkflow: undefined,
});

const emit = defineEmits<{
  (
    e: "workflow-found",
    workflow: WorkflowOut,
    workflowVersion?: WorkflowVersionOut,
  ): void;
}>();

const workflows = computed<WorkflowOut[]>(() => {
  if (formState.searchString.length > 0) {
    return workflowRepository.workflows.filter((workflow) =>
      workflow.name
        .toLowerCase()
        .includes(formState.searchString.toLowerCase()),
    );
  }
  return workflowRepository.workflows;
});

function modalClosed() {
  formState.searchString = "";
  formState.potentialUsers = [];
}

onMounted(() => {
  workflowRepository.fetchWorkflows();
});
</script>

<template>
  <bootstrap-modal
    :modal-id="props.modalId"
    :static-backdrop="true"
    modal-label="Search User Modal"
    v-on="{ 'hidden.bs.modal': modalClosed }"
  >
    <template #header>Search Workflow (Version)</template>
    <template #body>
      <div class="input-group mt-2 mb-4">
        <span class="input-group-text"
          ><font-awesome-icon icon="fa-solid fa-magnifying-glass"
        /></span>
        <input
          v-model.trim="formState.searchString"
          class="form-control"
          placeholder="Search for a workflow"
          maxlength="10"
        />
      </div>
      <div
        v-if="workflows.length > 0"
        :id="`accordion-${randomIDSuffix}`"
        class="accordion"
      >
        <div
          v-for="workflow of workflows"
          :key="workflow.workflow_id"
          class="accordion-item"
        >
          <h2 class="accordion-header">
            <button
              class="accordion-button collapsed"
              type="button"
              data-bs-toggle="collapse"
              :data-bs-target="`#collapse-workflow-${workflow.workflow_id}-${randomIDSuffix}`"
              :aria-controls="`collapse-workflow-${workflow.workflow_id}-${randomIDSuffix}`"
              @click="
                formState.selectedWorkflow =
                  formState.selectedWorkflow?.workflow_id ===
                  workflow.workflow_id
                    ? undefined
                    : workflow
              "
            >
              {{ workflow.name }}
            </button>
          </h2>
          <div
            :id="`collapse-workflow-${workflow.workflow_id}-${randomIDSuffix}`"
            class="accordion-collapse collapse"
            :data-bs-parent="`#accordion-${randomIDSuffix}`"
          >
            <div class="accordion-body">
              <div class="list-group">
                <button
                  v-for="version of workflow.versions"
                  :key="version.workflow_version_id"
                  type="button"
                  :data-bs-target="
                    props.backModalId ? '#' + props.backModalId : null
                  "
                  :data-bs-toggle="props.backModalId ? 'modal' : null"
                  :data-bs-dismiss="props.backModalId ? null : 'modal'"
                  class="list-group-item list-group-item-action"
                  @click="emit('workflow-found', workflow, version)"
                >
                  {{ version.version }}
                  <img
                    v-if="version.icon_url"
                    class="float-end"
                    :src="version.icon_url"
                    width="16"
                    height="16"
                  />
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div
        v-else-if="formState.searchString.length > 0"
        class="text-center fs-4"
      >
        <font-awesome-icon
          icon="fa-solid fa-magnifying-glass"
          class="mb-2"
          style="color: var(--bs-secondary); font-size: 3em"
        />
        <br />
        <span
          >Can't find workflow that contains <br />'{{
            formState.searchString
          }}'</span
        >
      </div>
      <div v-else class="text-center fs-4">
        <font-awesome-icon
          icon="fa-solid fa-xmark"
          class="mb-2"
          style="color: var(--bs-secondary); font-size: 3em"
        />
        <br />
        <span>There are no workflows in the system</span>
      </div>
    </template>
    <template #footer>
      <button
        v-if="backModalId"
        type="button"
        class="btn btn-secondary"
        :data-bs-target="'#' + props.backModalId"
        data-bs-toggle="modal"
      >
        Back
      </button>
      <button
        v-else
        type="button"
        class="btn btn-secondary"
        data-bs-dismiss="modal"
      >
        Close
      </button>
      <button
        v-if="allowSelectWorkflow"
        type="button"
        class="btn btn-success"
        :disabled="formState.selectedWorkflow == undefined"
        :data-bs-target="props.backModalId ? '#' + props.backModalId : null"
        :data-bs-toggle="props.backModalId ? 'modal' : null"
        :data-bs-dismiss="props.backModalId ? null : 'modal'"
        @click="emit('workflow-found', formState.selectedWorkflow!, undefined)"
      >
        Select
      </button>
    </template>
  </bootstrap-modal>
</template>

<style scoped></style>
